angular.module('beamng.apps')
  .directive('gearsApp', ['$log', function ($log) {
	

	let style = document.createElement('style');
    style.type = 'text/css';
    style.innerHTML = `
      @font-face {
        font-family: 'Hemi';
        src: url('/ui/modules/apps/GearsApp/hemi.ttf') format('truetype');
      }

      .gear-display {
        font-family: 'Hemi';
        color: white;
      }
    `;


    return {
      template:
      '<div style="width:100%; height:100%;" layout="column" layout-align="center center" class="bngApp" id="gears">' +
      '<span class="gear-display">{{gear}}</span>' +
      '</div>',
      replace: true,
      restrict: 'EA',
      link: function (scope, element, attrs) {
        StreamsManager.add(['electrics', 'engineInfo'])	
		
		document.getElementsByTagName('head')[0].appendChild(style);
	
	window.setTimeout( function() {
		var doc = document.getElementById('gears');
		var h = document.getElementById('gears').clientHeight;
		doc.style.fontSize=h+'px';
	}, 10);
		
		
		
        scope.$on('streamsUpdate', function (event, streams) {
			if (streams.engineInfo != null && streams.electrics != null) {
				        
				var mGear = streams.engineInfo[5]
					, maxRGears = streams.engineInfo[7]
				if(mGear<0){
					if(maxRGears<-1){
						scope.gear = 'R' + Math.abs(mGear)
					}
					else{
						scope.gear = 'R'
					}
				}
				else if(mGear==0){
					scope.gear = 'N'
				}
				else{
					scope.gear = mGear
				}
				scope.$digest()
			}
        })

        scope.$on('$destroy', function () {
          StreamsManager.remove(['electrics', 'engineInfo'])
        })
      }
    }
  }]);